
//  SuomennaNimet.cs  (c) 2003 Kari Laitinen

//  www.naturalprogramming.com

//  2004-10-20  Tiedosto luotu.

using System ;
using System.IO ;           // Classes for file handling.
using System.Collections ;  // ArrayList class etc.

class SuomennaNimet
{
   static void
   store_text_lines_to_file( ArrayList  given_array_of_text_lines,
                             string     given_file_name )
   {
      try
      {
         StreamWriter output_file  = 
                          new  StreamWriter( given_file_name ) ;

         for ( int line_index  =  0 ;
                   line_index  <  given_array_of_text_lines.Count ;
                   line_index  ++ )
         {
            output_file.WriteLine(
                          given_array_of_text_lines[ line_index ] ) ;
         }

         output_file.Close() ;
      }
      catch ( Exception )
      {
         Console.Write( "\n\n Cannot write to file \""
                     +  given_file_name  +  "\"\n" ) ;
      }
   }


   static void replace_names_in_file( string  original_file_name )
   {

      ArrayList names_to_replace  =  new  ArrayList() ;
      ArrayList replacement_names  =  new  ArrayList() ;

      try
      {
         StreamReader  nimien_kaannokset  =  new  StreamReader(
                                                 "nimikaannokset.txt" ) ;

         int  line_counter  =  0 ;
         bool end_of_file_encountered  =  false ;

         while ( end_of_file_encountered  ==  false )
         {
            string  name_translation_line   =  nimien_kaannokset.ReadLine() ;

            if ( name_translation_line  ==  null )
            {
               end_of_file_encountered  =  true ;
            }
            else
            {
               line_counter  ++ ;

               if ( name_translation_line.Length  !=  0  &&
                    name_translation_line[ 0 ]  !=  ' '  &&
                    name_translation_line[ 0 ]  !=  '/' )
               {
                  int index_of_first_space  =
                           name_translation_line.IndexOf( ' ' ) ;
                  int index_of_last_space   =
                           name_translation_line.LastIndexOf( ' ' ) ;

                  if ( index_of_first_space  ==  index_of_last_space )
                  {
                     Console.Write( "\n\n Format error on line: \n  "
                                 +  name_translation_line  +  "\n\n" ) ;
                  }
                  else
                  {
                     string  name_to_replace  =
                           name_translation_line.Substring( 0,
                                                   index_of_first_space ) ;
                     string  replacement_name  =
                           name_translation_line.Substring(
                                       index_of_first_space + 1,
                                       index_of_last_space -
                                       index_of_first_space - 1 ) ;

                     //  The names shall be inserted to the arrays in
                     //  such a way that the longest names come first.

                     int name_index  =  0 ;

                     while ( name_index  <  names_to_replace.Count  &&
                             ((string) names_to_replace[ name_index ]).Length
                                            >  name_to_replace.Length )
                     {
                        name_index  ++ ;
                     }

                     names_to_replace.Insert( name_index,
                                              name_to_replace ) ;
                     replacement_names.Insert( name_index,
                                               replacement_name ) ;
                  }
               }
            }
         }

         nimien_kaannokset.Close() ;
      }
      catch ( FileNotFoundException )
      {
         Console.Write( "\n Cannot open file nimikaannokset.txt \n" ) ;
      }

/****  The following loop was used to test this program:

      for ( int name_index  =  0 ;
                name_index  <  names_to_replace.Count ;
                name_index  ++  )
      {
         Console.Write( "\n "  +  names_to_replace[ name_index ]
                     +  "   "  +  replacement_names[ name_index ]  ) ;
      }

****/

      try
      {
         StreamReader original_file  =  new StreamReader(
                                                original_file_name ) ;
         ArrayList  original_text_lines  =  new  ArrayList() ;
         ArrayList  modified_text_lines  =  new  ArrayList() ;

         int  line_counter  =  0 ;
         bool end_of_file_encountered  =  false ;

         while ( end_of_file_encountered  ==  false )
         {
            string  text_line_from_file   =  original_file.ReadLine() ;

            if ( text_line_from_file  ==  null )
            {
               end_of_file_encountered  =  true ;
            }
            else
            {
               line_counter  ++ ;
               original_text_lines.Add( text_line_from_file ) ;

               for ( int name_index  =  0 ;
                         name_index  <  names_to_replace.Count ;
                         name_index  ++ )
               {
                  if ( text_line_from_file.IndexOf(
                         (string)  names_to_replace[ name_index ] )  !=  -1 )
                  {
                     text_line_from_file  =
                          text_line_from_file.Replace(
                              (string) names_to_replace[ name_index ],
                              (string) replacement_names[ name_index ] ) ;

                     Console.Write( "\n \""  +  names_to_replace[ name_index ]
                          +  "\" was replaced with \"" 
                          +  replacement_names[ name_index ]
                          +  "\" on line "  +  line_counter  ) ;
                  }
               }

               modified_text_lines.Add( text_line_from_file ) ;
            }
         }

         original_file.Close() ;

         string  backup_file_name  =  original_file_name  +  ".bak" ;

         store_text_lines_to_file( original_text_lines,
                                   backup_file_name   ) ; 
         store_text_lines_to_file( modified_text_lines,
                                   original_file_name ) ;
      }
      catch ( FileNotFoundException )
      {
         Console.Write( "\n Cannot open file " + original_file_name ) ;
      }
   }


   static void Main( string[] command_line_parameters )
   {
      string  file_name_given_by_user ;

      if ( command_line_parameters.Length  ==  1 )
      {
         file_name_given_by_user  =  command_line_parameters[ 0 ] ;
      }
      else
      {
         Console.Write( "\n This program can replace names in a "
                     +  "\n program file. Give first the file name :  " ) ;

         file_name_given_by_user  =  Console.ReadLine() ;
      }

      replace_names_in_file( file_name_given_by_user ) ;
   }
}



